'From Cuis 5.0 [latest update: #4488] on 9 December 2020 at 4:59:41 pm'!
'Description Tests for the simple environments package'!
!provides: 'SimpleEnvironmentsTest' 1 5!
!requires: 'SimpleEnvironments' 1 16 nil!
SystemOrganization addCategory: 'SimpleEnvironmentsTest'!




!classDefinition: #SimpleSimpleEnvironmentTestCase category: 'SimpleEnvironmentsTest'!
TestCase subclass: #SimpleSimpleEnvironmentTestCase
	instanceVariableNames: 'organizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimpleEnvironmentsTest'!
!classDefinition: 'SimpleSimpleEnvironmentTestCase class' category: 'SimpleEnvironmentsTest'!
SimpleSimpleEnvironmentTestCase class
	instanceVariableNames: ''!


!SimpleSimpleEnvironmentTestCase commentStamp: '<historical>' prior: 0!
I am a very simple test case for simple environments.!

!SimpleSimpleEnvironmentTestCase methodsFor: 'configuration' stamp: 'KLG 12/9/2020 13:25:11'!
classesForTest
	"Answer the subclasses to use."

	^ self classesForTestNames collect: [ :className |
		self classForTestNamed: className ]! !

!SimpleSimpleEnvironmentTestCase methodsFor: 'configuration' stamp: 'KLG 10/14/2020 14:40:06'!
classesForTestNames
	"Answer the names of the subclasses to use."

	^ #(TC1 TC2 TC3)! !

!SimpleSimpleEnvironmentTestCase methodsFor: 'configuration' stamp: 'KLG 10/14/2020 10:45:07'!
environmentName
	"Answer the name of the test environment."

	^ #TE1! !

!SimpleSimpleEnvironmentTestCase methodsFor: 'configuration' stamp: 'KLG 10/14/2020 10:50:19'!
shouldRemoveTestClasses
	"Answer true if we should remove the test classes after each test."

	^ false! !

!SimpleSimpleEnvironmentTestCase methodsFor: 'accessing' stamp: 'KLG 10/14/2020 14:39:32'!
classForTestNamed: aNameSymbol
	"Answer the test class denoted by a name symbol."

	^ SimpleEnvironments >> self environmentName >> aNameSymbol! !

!SimpleSimpleEnvironmentTestCase methodsFor: 'testing' stamp: 'KLG 12/9/2020 13:16:00'!
testAccessability
	"Test the accessability of classes."

	self classesForTestNames do: [ :subclassName |
		self shouldnt: [ Smalltalk includesKey: subclassName ].
		self 
			deny: subclassName =
				(SimpleEnvironments >> 
					self environmentName >> 
						subclassName :: name) ]! !

!SimpleSimpleEnvironmentTestCase methodsFor: 'testing' stamp: 'KLG 12/9/2020 16:59:06'!
testOwnOrganizer
	"Test our own system organizer."

	self
		assert: self classesForTest
		equals: 
			(organizer classesAt: self classCategory).
	"F:self createClassesForTestGlobaly."! !

!SimpleSimpleEnvironmentTestCase methodsFor: 'testing' stamp: 'KLG 12/9/2020 13:25:16'!
testSystemOrganizer
	"Test the global system organizer."

	self
		assert: self classesForTest
		equals: 
			(SystemOrganization classesAt: self classCategory)! !

!SimpleSimpleEnvironmentTestCase methodsFor: 'enumeration' stamp: 'KLG 10/14/2020 14:40:26'!
classesForTestDo: aBlock
	"Evaluate aBlock fro all test classes."
	
	self classesForTestNames do: [ :testClassName |
		aBlock value: (self classForTestNamed: testClassName) ]
	! !

!SimpleSimpleEnvironmentTestCase methodsFor: 'enumeration' stamp: 'KLG 10/14/2020 14:40:49'!
classesForTestReverseDo: aBlock
	"Evaluate aBlock for all test classes in reverse order."
	
	self classesForTestNames reverseDo: [ :testClassName |
		aBlock value: (self classForTestNamed: testClassName) ]
	! !

!SimpleSimpleEnvironmentTestCase methodsFor: 'setUp/tearDown' stamp: 'KLG 10/14/2020 14:39:32'!
addTestMethod: someSourceCode to: aClassOrClassName

	"Add a test method to a class."
	
	| class |
	class _ aClassOrClassName isBehavior 
		ifTrue: [ aClassOrClassName ]
		ifFalse: [ self classForTestNamed: aClassOrClassName ].
	class compile: someSourceCode classified: 'test code'  notifying: nil! !

!SimpleSimpleEnvironmentTestCase methodsFor: 'setUp/tearDown' stamp: 'KLG 12/9/2020 13:20:01'!
classCategory
	"Answer the category we use."	

	^ 'SimpleEnvironmentsTest - TestClasses'! !

!SimpleSimpleEnvironmentTestCase methodsFor: 'setUp/tearDown' stamp: 'KLG 12/9/2020 14:11:49'!
createClassesForTestGlobaly
	"Create the classes used for testting globaly."

	| superclass |
	superclass _ Object.
	self classesForTestNames do: [ :testClassName |
		superclass _
			superclass subclass: testClassName 
				instanceVariableNames:  '' 
				classVariableNames: ''
				poolDictionaries: '' 
				category: self classCategory ]! !

!SimpleSimpleEnvironmentTestCase methodsFor: 'setUp/tearDown' stamp: 'KLG 12/9/2020 14:11:19'!
createClassesForTestInEnvironment
	"Create the classes used for testting."

	| superclass |
	superclass _ Object.
	self classesForTestNames do: [ :testClassName |
		superclass _
			superclass subclass: testClassName 
				instanceVariableNames:  '' 
				classVariableNames: ''
				poolDictionaries: '' 
				category: self classCategory
				inSimpleEnvironment: self environmentName ]! !

!SimpleSimpleEnvironmentTestCase methodsFor: 'setUp/tearDown' stamp: 'KLG 12/9/2020 14:11:19'!
setUp
	"Set up a simple hierarchy of 3 classes."

	self createClassesForTestInEnvironment.
	self classesForTestNames do: [ :testClassName |
		self 
			addTestMethod:  
'm1

	^ ''m1 ', testClassName, '''
'
			to: testClassName ].
	organizer _ EnvironmentAwareSystemOrganizer new setDefaultList: #().
	self classesForTestDo: [ :testClass |
		organizer classify: testClass name under: self classCategory ]! !

!SimpleSimpleEnvironmentTestCase methodsFor: 'setUp/tearDown' stamp: 'KLG 10/14/2020 14:40:49'!
tearDown
	"Set up a simple hierarchy of 3 classes."

	self shouldRemoveTestClasses ifTrue: [
		self classesForTestReverseDo: [ :testClass | testClass removeFromSystem ] ]! !
