'From Haver 5.0 [latest update: #5001] on 16 December 2021 at 3:38:07 pm'!
'Description I am journal for forwarder sessions.

Mostly I save SMTP sessions.'!
!provides: 'ForwardJournal' 1 9!
!requires: 'PersistentObjectCollection' 1 4 nil!
!requires: 'PlanE' 1 40 nil!
SystemOrganization addCategory: 'ForwardJournal'!


!moduleCreation: ForwardJournal!
Modules newEnvironment: #ForwardJournal!

!interfacesOf: ForwardJournal!
Modules environment: #ForwardJournal ::
	interface: #UTI exporting: #(#Journal ) ::
	interface: #SPI aliasFor: #API!

!importsOf: ForwardJournal!
Modules environment: #ForwardJournal :: 
	import: #(#PlanE ) from: #API of: Modules>>#PlanE!

!classDefinition: (Modules>>#ForwardJournal>>#Journal) category: 'ForwardJournal'!
(Modules>>#PersistentObjectCollection>>#AbstractPersistentSingletonCollection) subclass: #Journal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ForwardJournal'
	inModule: #ForwardJournal!
!classDefinition: (Modules>>#ForwardJournal>>#Journal) class category: 'ForwardJournal'!
(Modules>>#ForwardJournal>>#Journal) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#ForwardJournal>>#Session) category: 'ForwardJournal'!
Object subclass: #Session
	instanceVariableNames: 'communicationItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ForwardJournal'
	inModule: #ForwardJournal!
!classDefinition: (Modules>>#ForwardJournal>>#Session) class category: 'ForwardJournal'!
(Modules>>#ForwardJournal>>#Session) class
	instanceVariableNames: ''!


!(Modules>>#ForwardJournal>>#Session) commentStamp: '<historical>' prior: 0!
I represent one session.!

!(Modules>>#ForwardJournal>>#Journal) methodsFor: 'instance creation' stamp: 'KLG 12/9/2021 20:32:37'!
sessionClass
	"Answer the session class."

	^ self class sessionClass! !

!(Modules>>#ForwardJournal>>#Journal) methodsFor: 'accessing' stamp: 'KLG 12/16/2021 14:49:27'!
addSession: someSessionData
	"Add a new session."

	^ self
		add: (someSessionData isKindOf: self sessionClass ::
			ifTrue: [ someSessionData ]
			ifFalse: [ self sessionClass for: someSessionData ] )! !

!(Modules>>#ForwardJournal>>#Journal) class methodsFor: 'class initialization' stamp: 'KLG 12/16/2021 14:42:39'!
initialize

	Modules environment: #SlowForward ifPresent: [ :slowForward |
		slowForward >> #SMTPForwarder ::
			forwarderCloseHook: [ :someCommunicationItems | self addSession: someCommunicationItems ] ]! !

!(Modules>>#ForwardJournal>>#Journal) class methodsFor: 'accessing' stamp: 'KLG 12/16/2021 14:43:59'!
addSession: someSessionData
	"Add a new session."


	^ self critical: [ self uniqueInstance addSession: someSessionData ]! !

!(Modules>>#ForwardJournal>>#Journal) class methodsFor: 'accessing' stamp: 'KLG 12/16/2021 14:44:42'!
sessions
	"Answer sessions as array."

	^ self elements! !

!(Modules>>#ForwardJournal>>#Journal) class methodsFor: 'accessing' stamp: 'KLG 12/16/2021 14:44:54'!
sessionsCollect: aBlock
	"Collect the value of aBlock for every session."

	^ self collect: aBlock! !

!(Modules>>#ForwardJournal>>#Journal) class methodsFor: 'accessing' stamp: 'KLG 12/16/2021 14:45:07'!
sessionsDo: aBlock
	"Evaluate aBlock for every session."

	self do: aBlock! !

!(Modules>>#ForwardJournal>>#Journal) class methodsFor: 'persistence' stamp: 'KLG 12/9/2021 19:41:28'!
storeFilename
	"Answer the filename of the store."

	^ 'ForwardJournal.planE'! !

!(Modules>>#ForwardJournal>>#Journal) class methodsFor: 'instance creation' stamp: 'KLG 12/9/2021 20:29:54'!
sessionClass
	"Answer the session class."

	^ Session! !

!(Modules>>#ForwardJournal>>#Session) methodsFor: 'accessing' stamp: 'KLG 12/9/2021 20:28:29'!
communicationItems
	"Answer the value of communicationItems"

	^ communicationItems ifNil: [ #() ]! !

!(Modules>>#ForwardJournal>>#Session) methodsFor: 'accessing' stamp: 'KLG 12/9/2021 20:28:01'!
communicationItems: aCollection
	"Set the value of communicationItems"

	communicationItems _ aCollection asArray! !

!(Modules>>#ForwardJournal>>#Session) class methodsFor: 'instance creation' stamp: 'KLG 12/9/2021 22:42:59'!
for: someCommunicationItems
	"Answer a new instance of mine for someCommunicationItems"

	^ self new communicationItems: someCommunicationItems; yourself! !
(Modules>>#ForwardJournal>>#Journal) initialize!
