'From Haver 5.0 [latest update: #4999] on 13 December 2021 at 4:19:42 pm'!
'Description I contain the tests for our forward journal.'!
!provides: 'ForwardJournalTest' 1 1!
!requires: 'ForwardJournal' 1 6 nil!
SystemOrganization addCategory: 'ForwardJournalTest'!


!moduleCreation: ForwardJournalTest!
Modules newEnvironment: #ForwardJournalTest!

!interfacesOf: ForwardJournalTest!
Modules environment: #ForwardJournalTest ::
	interface: #SPI aliasFor: #API ::
	interface: #UTI aliasFor: #API!

!importsOf: ForwardJournalTest!
Modules environment: #ForwardJournalTest :: 
	import: #(#Journal ) from: #UTI of: Modules>>#ForwardJournal!

!classDefinition: (Modules>>#ForwardJournalTest>>#ReopenTestCase) category: 'ForwardJournalTest'!
TestCase subclass: #ReopenTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ForwardJournalTest'
	inModule: #ForwardJournalTest!
!classDefinition: (Modules>>#ForwardJournalTest>>#ReopenTestCase) class category: 'ForwardJournalTest'!
(Modules>>#ForwardJournalTest>>#ReopenTestCase) class
	instanceVariableNames: ''!


!(Modules>>#ForwardJournalTest>>#ReopenTestCase) methodsFor: 'testing' stamp: 'KLG 12/13/2021 11:59:00'!
addRun
	"Add one run of sessions."

	self addRun: nil! !

!(Modules>>#ForwardJournalTest>>#ReopenTestCase) methodsFor: 'testing' stamp: 'KLG 12/13/2021 11:58:42'!
addRun: aRunId
	"Add one run of sessions."

	1 to: self runSize do: [ :count |
		Journal addSession: {count. aRunId} ]! !

!(Modules>>#ForwardJournalTest>>#ReopenTestCase) methodsFor: 'testing' stamp: 'KLG 12/13/2021 12:04:24'!
checkRun
	"Chekc one run."

	self checkRun: nil! !

!(Modules>>#ForwardJournalTest>>#ReopenTestCase) methodsFor: 'testing' stamp: 'KLG 12/13/2021 12:04:13'!
checkRun: aRunId
	"Chekc one run."

	self checkRun: aRunId startingAt: 1! !

!(Modules>>#ForwardJournalTest>>#ReopenTestCase) methodsFor: 'testing' stamp: 'KLG 12/13/2021 12:16:35'!
checkRun: aRunId startingAt: anIndex
	"Chekc one run."

	| count end start |
	count _ 1.
	start _ anIndex.
	end _ anIndex + self runSize - 1.
	Journal sessionsDo: [ :session |
		count between: start and: end :: ifTrue: [
			self assert: {count - start + 1. aRunId} equals: session communicationItems ].
		count _ count + 1 ]
! !

!(Modules>>#ForwardJournalTest>>#ReopenTestCase) methodsFor: 'testing' stamp: 'KLG 12/13/2021 11:53:18'!
runSize

	^ 10! !

!(Modules>>#ForwardJournalTest>>#ReopenTestCase) methodsFor: 'testing' stamp: 'KLG 12/13/2021 12:05:38'!
testReOpen
	"Test reopening the journal."

	self addRun.
	self checkRun		.
	Journal close.
	self checkRun
! !

!(Modules>>#ForwardJournalTest>>#ReopenTestCase) methodsFor: 'testing' stamp: 'KLG 12/13/2021 12:17:21'!
testReOpenAndAdd
	"Test reopening the journal an than adding some stuff."

	self addRun.
	self checkRun		.
	Journal close.
	self checkRun.
	self addRun: 1.
	self checkRun.
	self checkRun: 1 startingAt: 11.
	Journal close.
	self checkRun.
	self checkRun: 1 startingAt: 11.
! !

!(Modules>>#ForwardJournalTest>>#ReopenTestCase) methodsFor: 'testing' stamp: 'KLG 12/13/2021 12:17:37'!
testReOpenAndAddFirst
	"Test reopening the journal an than adding some stuff."

	self addRun.
	self checkRun		.
	Journal close.
	self addRun: 1.
	self checkRun.
	self checkRun: 1 startingAt: 11.
	Journal close.
	self checkRun.
	self checkRun: 1 startingAt: 11.
! !

!(Modules>>#ForwardJournalTest>>#ReopenTestCase) methodsFor: 'setUp/tearDown' stamp: 'KLG 12/13/2021 11:50:46'!
setUp
	"Start with a clean journal."

	super setUp.
	Journal close.
	Journal storeFilename asFileEntry delete! !
